# getignore

> Keep your .gitignore maintainable

[![npm](https://img.shields.io/npm/v/getignore.svg)](https://www.npmjs.com/package/getignore)
[![npm](https://img.shields.io/npm/dt/getignore.svg)](https://www.npmjs.com/package/getignore)
[![npm](https://img.shields.io/npm/l/getignore.svg)](https://www.npmjs.com/package/getignore)

[![Standard - JavaScript Style Guide](https://img.shields.io/badge/code%20style-standard-brightgreen.svg)](http://standardjs.com/)
[![Known Vulnerabilities](https://snyk.io/test/npm/getignore/badge.svg)](https://snyk.io/test/npm/getignore)
[![Build Status](https://api.travis-ci.org/michel-zimmer/getignore.svg?branch=master)](https://travis-ci.org/michel-zimmer/getignore)
[![Coverage Status](https://coveralls.io/repos/github/michel-zimmer/getignore/badge.svg)](https://coveralls.io/github/michel-zimmer/getignore)

Combine custom ignore rules and templates from [github/gitignore](https://github.com/github/gitignore).

Wouldn't it be nice to write this

```gitignore
test/tmp

#==Node
#==Global/VisualStudioCode
```

instead of this?

```gitignore
test/tmp

## getignore: https://raw.githubusercontent.com/github/gitignore/master/Node.gitignore ##
# Logs
logs
*.log
npm-debug.log*
[54 lines more...]

## getignore: https://raw.githubusercontent.com/github/gitignore/master/Global/VisualStudioCode.gitignore ##
.vscode/*
!.vscode/settings.json
[3 lines more ...]
```

Or to include your custom ignore rules, but in an organized way?

```gitignore
#=file://support/CustomProject.gitignore
#=file://support/CustomDependency.gitignore
#==Node
```

## Installation

```shell
npm install -g getignore
```

Usually you want to install this with the global flag, so that you have it available across your system. For [npm](https://www.npmjs.com/) projects you can also set it as a development dependency.

```shell
npm install --save-dev getignore
```

## Usage

Write the ignore rules into `.getignore` and then run `getignore` to generate `.gitignore`.

**The `.gitignore` file gets overridden!** But this is what you want and you are using version control anyway, so that should not be a problem.

### Syntax

- *default gitignore rules*
- `#=<url>` - fetch `url` and replace (supported protocols are HTTP and HTTPS and the file system)
  - `#=http://...`
  - `#=https://...`
  - `#=file://...`
- `#==<name>` - fetch `name` from [github/gitignore](https://github.com/github/gitignore) and replace

The syntax for `.getignore` files is the same syntax as for `.gitignore` files. But on top of that, every line beginning with `#=` is fetched and replaced. `#==` fetches from [github/gitignore](https://github.com/github/gitignore).
