const stdMocks = require('std-mocks')

/**
 * Wraps the execution of the callback with std-mocks and includes stdout and stderr in return value.
 * @param {function():Promise} callback
 * @return {Promise}
 */
function stdMocksWrapper (callback) {
  stdMocks.use()
  return callback()
    .then(originalValue => {
      let output = stdMocks.flush()
      stdMocks.restore()
      return {
        value: originalValue,
        stdout: output.stdout,
        stderr: output.stderr
      }
    })
    .catch(err => {
      stdMocks.restore()
      throw err
    })
}

module.exports = stdMocksWrapper
