/* eslint-env mocha */
const chai = require('chai')
var chaiAsPromised = require('chai-as-promised')
chai.use(chaiAsPromised)
const expect = chai.expect
const mock = require('mock-fs')
const fs = require('fs')

const readFilePromised = require('../../lib/read-file-promised')

describe('readFilePromised', function () {
  afterEach(function () {
    mock.restore()
  })

  it('should resolve with file contents', function () {
    mock({'test.txt': 'some file contents'})
    expect(readFilePromised('test.txt')).to.become('some file contents')
  })

  it('should reject with error', function (done) {
    mock()
    fs.readFile('test.txt', err => {
      expect(readFilePromised('test.txt').catch(err => err.message)).to.become(err.message)
      done()
    })
  })
})
